//+------------------------------------------------------------------+
//|                                                   Beta_v1.00.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+



extern string        ExpertName                    = "=== Beta_v1.00 ===";

extern string        GeneralParameters             = "===== GENERAL PARAMETERS =====";

extern int           Magic                         = 123456;

extern string        MoneyManagement               = "===== MONEY MANAGEMENT =====";

extern double        Lots                          = 0.1;
   
extern double        LotExponent                   = 1.8; 
 
extern bool          USE_MM                        = false; 
extern double        Risk                          = 0.1;     // Risk (Lots = Balance*0.001*Risk)
extern bool          OpenPlay                      = true;  

input string         OrderSettings                 = "===== ORDER SETTINGS =====";

extern bool          Long_Position                 = true;
extern bool          Short_Position                = true;

extern int           TP1                           = 0; 
extern int           Avr_TP                        = 0;
extern double        PipStep                       = 20.0; 
extern double        koefPipStep                   = 1.0;
extern int           MaxOrdersAvr                  = 5; 

extern string        _Fractal_                     ="===== FRACTAL=====";

extern int           Fractal_tf                    = 0; 
extern double        Fractal_Pips                  = 20;
 

extern string        _Filter_TMA_                  ="===== FILTER TMA WITH DISTANCES =====";

extern bool          USE_TMA_Filter                = true;
extern int           TimeFrame_tma                 = 0;  
extern int           HalfLength                    = 70;
extern int           Price                         = PRICE_CLOSE;
extern double        ATRMultiplier                 = 1.2;
extern int           ATRPeriod                     = 100;
extern bool          Interpolate                   = true;

//******************************************************************************************************************************************************
//******************************************************************************************************************************************************

int      SL=0;
int      ticket;
int      pos;
int      close_pos;
int      prevtime;
int      mp;
int      minstop;
int      last_open;
int      lot_digit;
int      orders_buy;
int      orders_sell;
int      LastOpenSellMagic;
int      LastOpenBuyTicket;
int      LastOpenSellTicket;
int      orders_seria;
int      LastCloseType;
int      TimeSleep;
int      LastCloseTime;
int      Last_UP_Time;
int      Last_DN_Time;
int      LastTimeBuy;
int      LastTimeSell;
int      LastOpenTime;
int      point_num=0;
int      time_bar;

color    col;
 
string   comm;
string   gl_timeseria;
string   LastOrderComment;

double   op;
double   sl;
double   tp;
double   price;
double   minlot;
double   maxlot;
double   lotstep;
double   lots;
double   lot;
double   Doliv;
double   LastOpenPriseOpenBuy; 
double   LastOpenPriseOpenSell;
double   BuyLots;
double   SellLots; 
double   LastOpenBuySL; 
double   LastOpenSellSL;
double   LastOpenBuyTP; 
double   LastOpenSellTP;
double   LastOpenBuyLots;
double   LastOpenSellLots;
double   PrevCl; 
double   CurrCl;
double   BuyProfit;
double   SellProfit; 
double   LastCloseSL; 
double   LastCloseLots; 
double   LastCloseProfit;
double   LastCloseTP;
double   HistProfitSeria;
 
datetime OpenBuyTime;
datetime OpenSellTime;

//******************************************************************************************************************************************************

void Set_Marker() 
{
   point_num++;
   string obj_name=StringConcatenate("TMA_point_",point_num);
   if(ObjectFind(obj_name)>=0) ObjectDelete(obj_name);
   double obj_price=tma(0,1);
   ObjectCreate(obj_name,OBJ_ARROW,0,Time[0],obj_price);
   ObjectSet(obj_name,OBJPROP_ARROWCODE,172);
   ObjectSet(obj_name,OBJPROP_COLOR,Red);
   ObjectSet(obj_name,OBJPROP_WIDTH,1);
}

//******************************************************************************************************************************************************

double NL(double lots)
{
   double MaxLots=MarketInfo(Symbol(),MODE_MAXLOT);
   double MinLots=MarketInfo(Symbol(),MODE_MINLOT);
   double StepLots=MarketInfo(Symbol(),MODE_LOTSTEP);
   double lot=NormalizeDouble(lots/StepLots,0)*StepLots;
   if (lot>MaxLots) lot=MaxLots; 
   if (lot<MinLots) lot=MinLots; 
   return (lot); 
}

//******************************************************************************************************************************************************

double ND(double x)
{
   return(NormalizeDouble(x,Digits));
}

//******************************************************************************************************************************************************

double Get_Lots()
{
   lots =Lots; 
   if(USE_MM )lots=AccountBalance()*0.001*Risk;
   return(NL(lots));
}

//******************************************************************************************************************************************************

int TMA_Filter()
{
   if(!USE_TMA_Filter)return(2);
   double up=tma(1,1),dn;
   if(Close[1]>up)return(-1);
   else
   {
      dn=tma(2,1);
      if(Close[1]<dn)return(1);
      else
      {
         return(0);
      }
   }

   return(0);
}

//******************************************************************************************************************************************************

double tma(int buf, int shift)
{
   string TimeFrame       = "current time frame";
   return(iCustom(NULL,TimeFrame_tma,"TMA with Distances", TimeFrame , HalfLength, Price,ATRMultiplier,ATRPeriod,Interpolate,0,0,0,0,0,0,buf,shift));
}

//******************************************************************************************************************************************************

int init()
{
   mp=1; 
   if(Digits==3 || Digits==5)mp=10;
   SL*=mp; 
   TP1*=mp; 
   Avr_TP*=mp; 
   PipStep*=mp;   
   prevtime=Time[0];
   return(0);
}

//******************************************************************************************************************************************************

int deinit()
{
   return(0);
}

//******************************************************************************************************************************************************

int start()
{
   if(!IsTradeAllowed())return(0);

   bool can_buy = false;
   bool   can_sell= false;
     
   if (time_bar!=Time[0]) 
   {
      if(Low[0]<Low[1] && Low[0]<Low[2] && Bid>=Low[0]+Fractal_Pips*Point) can_buy=true;
      if(High[0]>High[1] && High[0]>High[2] && Bid<=High[0]-Fractal_Pips*Point) can_sell=true;
      if(Low[1]>Low[2] && Low[2]<Low[3] && Low[2]<Low[4]) can_buy=true;      
      if(High[1]<High[2] && High[2]>High[3] && High[2]>High[4]) can_sell=true;      
      if(can_buy || can_sell) time_bar=Time[0];
   }
  
   if(!can_buy && !can_sell) 
   {
      if(prevtime==Time[0])return(0); prevtime=Time[0];
   }
  
   OrdersScaner();
   int filter=0; 
  
   int k=0; if(TP1!=0)k=1;
   if(orders_buy >k && can_sell && BuyProfit >0) 
   {
      if(TMA_Filter()!=-1) 
      {
         CloseAll(OP_BUY );
         OrdersScaner();
      }
   }
   
   if(orders_sell>k && can_buy && SellProfit>0) 
   {
      if(TMA_Filter()!=-1) 
      {
         CloseAll(OP_SELL);
         OrdersScaner();
      }
   }
  
   if(orders_buy>0 && orders_buy<MaxOrdersAvr)
   if(LastOpenPriseOpenBuy-Ask>= PipStep(orders_buy)*Point)
   if(can_buy)
   {
      filter=TMA_Filter();
      if(filter==1 || filter==2)
      if(OpenBuyMarket (Magic,NL(LastOpenBuyLots*LotExponent),SL,0,"BUYavr_"+(orders_buy+1),Blue)>0)
      {
         LastTimeBuy=Time[0];if(OpenPlay)ALERT(1); 
         if(Avr_TP>0)Modify_avr(OP_BUY,BU(OP_BUY));OrdersScaner();
      }
      else 
      {         
         Sleep(10000);prevtime=Time[1];
      }
   }
  
   if(orders_sell>0 && orders_sell<MaxOrdersAvr) 
   if(Bid-LastOpenPriseOpenSell>= PipStep(orders_sell)*Point)
   if(can_sell)
   {
      filter=TMA_Filter();
      if(filter==-1 || filter==2)
      if(OpenSellMarket (Magic,NL(LastOpenSellLots*LotExponent),SL,0,"SELLavr_"+(orders_sell+1),Red)>0)
      {
         LastTimeSell=Time[0];if(OpenPlay)ALERT(-1); 
         if(Avr_TP>0)Modify_avr(OP_SELL,BU(OP_SELL));OrdersScaner();
      }
      else 
      {
         Sleep(10000);prevtime=Time[1];
      }
   }
  
   if(Long_Position && orders_buy==0) 
   {
      if(can_buy) 
      {
         if(TMA_Filter()==1) 
         {
            if(OpenBuyMarket (Magic,Get_Lots(),SL,TP1,"start",Blue)>0) 
            {
               Set_Marker(); 
               LastTimeBuy=Time[0];
               if(OpenPlay) ALERT(1); 
               return(0);
            }
            else
            {
               Sleep(10000);
               prevtime=Time[1];
            }
         }
      }
   }
  
   if(Short_Position && orders_sell==0) 
   {
      if(can_sell) 
      {
         if(TMA_Filter()==-1) 
         {
            if(OpenSellMarket(Magic,Get_Lots(),SL,TP1,"start",Red )>0) 
            {
               Set_Marker(); 
               LastTimeSell=Time[0];
               if(OpenPlay)ALERT(-1);
               return(0);
            }
            else
            {
               Sleep(10000);
               prevtime=Time[1];
            }
         }
      }
   }
 
  return(0); 
}

//******************************************************************************************************************************************************

void Fractal_Parametrs()
{
   int up=0,dn=0; Last_UP_Time=0; Last_DN_Time=0;
   for(int i=1; i<Bars; i++)
   {
      if(dn==0)if(iFractals(NULL,Fractal_tf,MODE_LOWER,i)>0)dn=i; 
      if(up==0)if(iFractals(NULL,Fractal_tf,MODE_UPPER,i)>0)up=i; 
      if(up>0 && dn>0)break;
   }
   Last_UP_Time=iTime(NULL,Fractal_tf,up);
   Last_DN_Time=iTime(NULL,Fractal_tf,dn);
}

//******************************************************************************************************************************************************

void ALERT(int type)
{
   if(type== 1)Alert(" // ",Symbol()," // ",Ask," //  - ",TimeToStr(TimeCurrent()));
   if(type==-1)Alert(" // ",Symbol()," // ",Bid," // - ",TimeToStr(TimeCurrent()));
}

//******************************************************************************************************************************************************

int PipStep(int orders)
{
   if(koefPipStep<1)koefPipStep=1;
   return(MathCeil(PipStep*MathPow(koefPipStep,orders)));
}

//******************************************************************************************************************************************************

int OrdersScaner()
{
   orders_buy              = 0;
   orders_sell             = 0;
   LastOpenPriseOpenBuy    = 0;
   LastOpenPriseOpenSell   = 0;
   LastOpenBuySL           = 0;  
   LastOpenSellSL          = 0;
   LastOpenBuyTP           = 0;  
   LastOpenSellTP          = 0; 
   LastOpenBuyTicket       = 0;
   LastOpenSellTicket      = 0;
   OpenBuyTime             = 0;
   OpenSellTime            = 0; 
   LastOpenBuyLots         = 0; 
   LastOpenSellLots        = 0;
   BuyLots                 = 0;
   SellLots                = 0; 
   LastOrderComment        = ""; 
   BuyProfit               = 0;
   SellProfit              = 0;
    
   for (int i=OrdersTotal();i>=1;i--)
   {
      if(OrderSelect(i-1, SELECT_BY_POS, MODE_TRADES)==FALSE)break;
      if(OrderSymbol ()!= Symbol())continue;
      if(OrderMagicNumber()!=Magic)continue;
      if(OrderType() == OP_BUY )
      {
         if(OpenBuyTime < OrderOpenTime())
         {
            OpenBuyTime=OrderOpenTime(); LastOpenPriseOpenBuy=OrderOpenPrice();
            LastOpenBuyTP = OrderTakeProfit();LastOpenBuySL = OrderStopLoss();                    
            LastOrderComment=OrderComment();
            LastOpenBuyTicket=OrderTicket();LastOpenBuyLots=OrderLots();
         } 
         orders_buy ++;
         BuyLots+=OrderLots();BuyProfit+=OrderProfit()+OrderSwap()+OrderCommission();
      }
      
      if(OrderType() == OP_SELL )
      {
         if(OpenSellTime < OrderOpenTime())
         {
            OpenSellTime=OrderOpenTime(); LastOpenPriseOpenSell=OrderOpenPrice();
            LastOpenSellTP = OrderTakeProfit();LastOpenSellSL = OrderStopLoss();
            LastOrderComment=OrderComment();
            LastOpenSellTicket=OrderTicket();LastOpenSellLots=OrderLots();
         } 
         orders_sell ++;
         SellLots+=OrderLots();SellProfit+=OrderProfit()+OrderSwap()+OrderCommission();
      }   
               
   }
    
   int status=0;
   if(orders_buy+orders_sell>0)status=1; 
   return(status);
}

//******************************************************************************************************************************************************

int Modify_avr(int type, double TP)
{
   double tp,sl; 
   int cnt=0;
   OrdersScaner();
   if(orders_buy >0 && type== OP_BUY)
   {
      TP+=Avr_TP*Point;
      sl=LastOpenBuySL;
   }
   
   if(orders_sell>0 && type==OP_SELL)
   {
      TP-=Avr_TP*Point;
      sl=LastOpenSellSL;
   }
   
   for (int i=OrdersTotal();i>=1;i--)
   {
      if(OrderSelect(i-1, SELECT_BY_POS, MODE_TRADES))
      {
         if(OrderSymbol ()!= Symbol())continue;
         if(OrderType()!= type)continue;
         if(OrderMagicNumber()!=Magic)continue;
         tp=OrderTakeProfit();
         if(tp-TP!=0 )
         {
            tp=TP;
            if(OrderModify(OrderTicket(), OrderOpenPrice(),sl,tp, 0, Lime))cnt++;
         }
         
      }
   }
   return(cnt);
}

//******************************************************************************************************************************************************

double BU(int type)
{
   int Spr= MarketInfo(Symbol(),MODE_SPREAD);

   double B2_B=0;
   double B2_S=0;
   double B2_LB=0;
   double B2_LS=0;
   double BSw=0;
   double SSw=0;
   for(int b2=0;b2<OrdersTotal();b2++)
   {   
      if(OrderSelect(b2,SELECT_BY_POS,MODE_TRADES)==false)    continue;
      if(OrderSymbol()!=Symbol())continue;
      if(OrderMagicNumber()!=Magic)continue; 
      if (OrderType()==OP_BUY && type==OP_BUY)
      {
         B2_B=((B2_B*B2_LB)+(OrderOpenPrice()*OrderLots()))/(B2_LB+OrderLots());
         B2_LB=B2_LB+OrderLots(); BSw=BSw+OrderSwap();
      }
      
      if (OrderType()==OP_SELL && type==OP_SELL)
      {
         B2_S=((B2_S*B2_LS)+(OrderOpenPrice()*OrderLots()))/(B2_LS+OrderLots());
         B2_LS=B2_LS+OrderLots(); SSw=SSw+OrderSwap();
      }
   }
      
   double M2B=0;
   double M2S=0;
   double M5;           
   if (B2_LB>B2_LS)
   { 
      for(int J2=0;J2<10000;J2++)
      {
         M2B=J2*B2_LB*10;
         M2S=((B2_B-B2_S+Spr*Point)/Point+J2)*(B2_LS*(-10));
         if (M2B+M2S+BSw+SSw>=0)
         { 
            M5=NormalizeDouble(B2_B+J2*Point,Digits);
            break;
         }
      }
   }
    
   if (B2_LS>B2_LB)
   { 
      for(int J3=0;J3<10000;J3++)
      {
         M2S=J3*B2_LS*10;
         M2B=((B2_B-B2_S+Spr*Point)/Point+J3)*(B2_LB*(-10));
         if (M2S+M2B+BSw+SSw>=0)
         {
            M5=NormalizeDouble(B2_S-J3*Point,Digits);
            break;
         }
      }
   }

   return(M5);
}

//******************************************************************************************************************************************************

int OpenBuyMarket(int Magic,double lots,int SL,int TP,string _comm,color clr)
{ 
   if(AccountFreeMarginCheck(Symbol(), OP_BUY, lots) <= 0 || GetLastError() == 134)
   {
      Sleep(5000);
      return(0);
   }
   
   while (IsTradeContextBusy()) Sleep(1000); RefreshRates();
   double ask=NormalizeDouble(Ask,Digits);
   int ticket=OrderSend(Symbol(),OP_BUY,lots,ask,3*mp,0,0,_comm,Magic,0,clr);
   if(ticket>0)
   {
      if(SL+TP>0)
      {
         if (OrderSelect(ticket, SELECT_BY_TICKET))
         {
            while (IsTradeContextBusy()) Sleep(1000); RefreshRates();
            op=OrderOpenPrice();
            minstop= MarketInfo(Symbol(),MODE_STOPLEVEL);
            if (SL!=0) sl = ND(op-SL*Point); else sl = 0;
            if (TP!=0) tp = ND(op+TP*Point); else tp = 0;
            if (TP!=0)if(tp-Ask<minstop*Point)tp=Ask+minstop*Point;
            if (SL!=0)if(Bid-sl<minstop*Point)sl=Bid-minstop*Point;
            if(!OrderModify(ticket, op,sl,tp, 0, Blue))
            Print (" BUY ",  GetLastError()); 
            else return(ticket);
         }
      } 
      else  return(ticket);
   }
                                            
   else 
   { 
      Print (" BUY ",  GetLastError());  return(0);
   }
}

//******************************************************************************************************************************************************

int OpenSellMarket(int Magic,double lots,int SL,int TP ,string _comm,color clr)
{ 
   if(AccountFreeMarginCheck(Symbol(), OP_SELL, lots) <= 0 || GetLastError() == 134)
   {
      Sleep(5000);
      return(0);
   }
       
   while (IsTradeContextBusy()) Sleep(1000); RefreshRates();
   double bid=NormalizeDouble(Bid,Digits);
   int ticket=OrderSend(Symbol(),OP_SELL,lots,bid,3*mp,0,0,_comm,Magic,0,clr);
   if(ticket>0)
   {
      if(SL+TP>0)
      {
         if (OrderSelect(ticket, SELECT_BY_TICKET))
         {
            while (IsTradeContextBusy()) Sleep(1000); RefreshRates();
            op=OrderOpenPrice();
            minstop= MarketInfo(Symbol(),MODE_STOPLEVEL);
            if (SL!=0) sl = ND(op+SL*Point); else sl = 0;
            if (TP!=0) tp = ND(op-TP*Point); else tp = 0;
            if (TP!=0)if(Bid-tp<minstop*Point)tp=Bid-minstop*Point;
            if (SL!=0)if(sl-Ask<minstop*Point)sl=Ask+minstop*Point;
            if(!OrderModify(ticket, op,sl,tp, 0, Red))
            Print (" SELL ",  GetLastError()); 
            else return(ticket);
         }
      } 
      else  return(ticket);
   }
         
   else 
   { 
      Print ("SELL ",   GetLastError()); return(0);
   }
}

//******************************************************************************************************************************************************

int CloseAll(int type)
{
   bool     UseSound          = 0;
   int      Slippage          = 5*mp;
   int      NumberOfTry       = 4;
   int      PauseAfterError   = 5;
   color    clCloseBuy        = Blue;
   color    clCloseSell       = Red;
   string   NameFileSound     = "";
   int      cnt               = 0;
   bool     fc;
   double   pp;
   int      err; 
   int      i; 
   int      it;
   int      magic;
 
   for (i=OrdersTotal()-1; i>=0; i--) 
   {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      {
         if (OrderSymbol()==Symbol() )
         {
            if (OrderType()!=type)continue;
            magic=OrderMagicNumber();
            if(magic== Magic)
            {
               fc=False;
               for (it=1; it<=NumberOfTry; it++) 
               {
                  while (!IsTradeAllowed()) Sleep(500);
                  RefreshRates();
                  if (OrderType()==OP_BUY ) 
                  {
                     pp=MarketInfo(OrderSymbol(), MODE_BID);
                     fc=OrderClose(OrderTicket(), OrderLots(), pp, Slippage, clCloseBuy);
                     if (fc) 
                     {
                        if (UseSound) PlaySound(NameFileSound); break;
                     }
                     else 
                     { 
                        err=GetLastError(); Print("Error",err);Sleep(1000*PauseAfterError);
                     }
                  }
                  if (OrderType()==OP_SELL ) 
                  {
                     pp=MarketInfo(OrderSymbol(), MODE_ASK);
                     fc=OrderClose(OrderTicket(), OrderLots(), pp, Slippage, clCloseSell);
                     if (fc) 
                     {
                        if (UseSound) PlaySound(NameFileSound); break;
                     }
                     else 
                     {
                        err=GetLastError(); Print("Error",err); Sleep(1000*PauseAfterError);
                     }
                  }
               }
            }
         }
      }
   }

   for (i=OrdersTotal()-1; i>=0; i--) 
   {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      if (OrderSymbol()!=Symbol()) continue; 
      if (OrderType()!=type)continue;
      magic=OrderMagicNumber();
      if(magic!=Magic) continue;
      if(OrderType()==OP_BUY ||OrderType()==OP_SELL)cnt++;
   }
   
   if(cnt==0)return(1);
   else return (0);
}

//******************************************************************************************************************************************************
//******************************************************************************************************************************************************